# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

Name:           jtopen
Version:        7.4
Release:        1%{?dist}
Epoch:          0
Summary:        IBM Toolbox for Java
License:        IBM Public License
Group:          Development/Java
URL:            http://jt400.sourceforge.net/
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:      noarch
#Source0:        http://downloads.sourceforge.net/project/jt400/JTOpen-full/7.4/jtopen_7_4_source.zip
Source0:        jtopen_7_4_source_pure.zip
Source1:        http://downloads.sourceforge.net/project/jt400/JTOpen-full/7.4/jtopen_7_4.zip
Source2:        ftp://ftp.software.ibm.com/as400/toolbox/sslightx.zip
Source3:        http://downloads.sourceforge.net/project/jt400/JTOpen-full/7.4/jtopen_7_4_jdbc40_jdk6.zip
Source4:        jt400-7.4.pom
Patch0:         jtopen-build.patch

BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  servletapi4

Requires:  java-devel >= 0:1.6.0

%description
The IBM Toolbox for Java is a library of Java classes 
supporting the client/server and internet programming models
to a system running IBM i (or i5/OS or OS/400). The classes 
can be used by Java applets, servlets, and applications to 
easily access IBM i data and resources.
The Toolbox does not require additional client support over 
and above what is provided by the Java Virtual Machine and 
TCP/IP.
JTOpen is the open source version of the IBM Toolbox for 
Java licensed program product, and contains the identical 
code. Both have been tested on a wide variety of platforms, 
including AIX, IBM i, Linux, Solaris, and Windows.
Details of all the functions and capabilities are available 
on the IBM Toolbox for Java web page. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -qq -c
unzip -o -q %{SOURCE1}
unzip -o -q %{SOURCE3}
mkdir src
#mv com src
mv utilities src
mkdir contrib
mkdir jdbc40-combined
mv com jdbc40-combined
pushd jdbc40-combined
unzip -o -q ../lib/src.zip
%patch0 -b .sav0
cp build.* ..
popd
mkdir include
ln -sf $(build-classpath servlet_2_3_api) include/servlet.jar
cp %{SOURCE2} include
cp lib/jt400.jar include
rm -rf jdbc40-combined/com/ibm/as400/micro/
mkdir build
cp *manifest.txt build
cp *.includes build
find . -name "*.class" -exec rm {} \;

%build
export CLASSPATH=$(pwd)/include/sslightx.zip:$(pwd)/lib/jt400.jar:$(pwd)/lib/jui400.jar:$(build-classpath ant):.
export ANT_OPTS="-Xmx1024m -XX:MaxPermSize=128m"
javac *.java
ant -Dbuild.sysclasspath=last -Dbuild=$(pwd) all

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 0644 dist/jt400.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jt400-%{version}.jar
install -m 0644 dist/jt400Native.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jt400Native-%{version}.jar
install -m 0644 dist/jt400Proxy.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jt400Proxy-%{version}.jar
install -m 0644 dist/jt400Servlet.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jt400Servlet-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name}
for jar in *-%{version}*.jar; do ln -sf ${jar} `echo ${jar} | sed "s|-%{version}||g"`;done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE4} \
    $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-jt400.pom
%add_to_maven_depmap net.sf.jt400 jt400 %{version} JPP/%{name} jt400

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%changelog
* Sun Oct 09 2011 Ralph Apel <r.apel@r-apel.de> 0:7.4-1
- first release
- largely pristine
- no microedition support


